// We will use this to sample each coefficient separately
data {
  real y; // coeff j of observation
  int<lower=0> j; // index of coefficient
  real<lower=0> sn; // 1/sqrt{n}=1/sn is noise level
  real<lower=0> alpha; // prior regularity
  int<lower=1> nu; // student distribution's degrees of freedom
  int<lower=0> l; // 0 or 1, 0 for direct problem, 1 for inverse problem
  real<lower=0, upper=1> rho; // rho posterior 
}

parameters {
  real f; // vector of unknown
}

model {
    target += student_t_lpdf(f|nu, 0, j^(-0.5-alpha));
    target += normal_lpdf(y|f*(((j-0.5)*pi())^(-l)), 1/sn)*(rho);
}

